To search for a specific text string or number, use the search method to search the text in cells with the specified criteria, as shown in the following example:
Use the SearchCondition to customize the search parameters.
The search result is an object with the following properties:
searchFoundFlag: An enumeration that specifies what is matched.
foundSheetIndex: The index of the sheet in which a match is found.
foundRowIndex: The index of the row at which a match is found.
foundColumnIndex: The index of the column at which a match is found.
foundString: The found string.
var spreadNS = GC.Spread.Sheets, spread;
window.onload = function () {
spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 3});
spread.suspendPaint();
initSpread(spread);
spread.resumePaint();
};
function initSheet(sheet) {
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 100);
sheet.setValue(0, 0, 'Value');
sheet.setValue(1, 0, 1);
sheet.setValue(2, 0, 2);
sheet.setValue(3, 0, 3);
sheet.addSpan(0, 1, 1, 2);
sheet.setValue(0, 1, 'Formula Result');
sheet.setValue(1, 1, 'SUM(A2:A3)');
sheet.setFormula(1, 2, '=SUM(A2:A3)');
var comment = null
sheet.setTag(6, 2, "tag: C7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 2).comment(comment);
sheet.setTag(16, 2, "tag: C17");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C17");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(16, 2).comment(comment);
sheet.setTag(6, 8, "tag: I7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 8).comment(comment);
sheet.setTag(11, 8, "tag: I12");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I12");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(11, 8).comment(comment);
}
function initSpread(spread) {
var sheet1 = spread.getSheet(0);
initSheet(sheet1);
var sheet2 = spread.getSheet(1);
initSheet(sheet2);
document.getElementById('btnFindNext').onclick = function () {
var sheet = spread.getActiveSheet();
var searchCondition = getSearchCondition();
var within = document.getElementById('searchWithin').value;
var searchResult = null;
if (within == "sheet") {
var sels = sheet.getSelections();
if (sels.length > 1) {
searchCondition.searchFlags |= spreadNS.Search.SearchFlags.blockRange;
} else if (sels.length == 1) {
var spanInfo = getSpanInfo(sheet, sels[0].row, sels[0].col);
if (sels[0].rowCount != spanInfo.rowSpan && sels[0].colCount != spanInfo.colSpan) {
searchCondition.searchFlags |= spreadNS.Search.SearchFlags.blockRange;
}
}
searchResult = getResultSearchinSheetEnd(searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == spreadNS.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinSheetBefore(searchCondition);
}
} else if (within == "workbook") {
searchResult = getResultSearchinSheetEnd(searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == spreadNS.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinWorkbookEnd(searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == spreadNS.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinWorkbookBefore(searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == spreadNS.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinSheetBefore(searchCondition);
}
}
if (searchResult != null && searchResult.searchFoundFlag != spreadNS.Search.SearchFoundFlags.none) {
spread.setActiveSheetIndex(searchResult.foundSheetIndex);
var sheet = spread.getActiveSheet();
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex);
if ((searchCondition.searchFlags & spreadNS.Search.SearchFlags.blockRange) == 0) {
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex, 1, 1);
}
//scrolling
if (searchResult.foundRowIndex < sheet.getViewportTopRow(1)
|| searchResult.foundRowIndex > sheet.getViewportBottomRow(1)
|| searchResult.foundColumnIndex < sheet.getViewportLeftColumn(1)
|| searchResult.foundColumnIndex > sheet.getViewportRightColumn(1)
) {
sheet.showCell(searchResult.foundRowIndex,
searchResult.foundColumnIndex,
spreadNS.VerticalPosition.center,
spreadNS.HorizontalPosition.center);
} else {
sheet.repaint();
}
} else {
//Not Found
alert('Not Found');
}
};
}
function getSpanInfo(sheet, row, col) {
var span = sheet.getSpans(new spreadNS.Range(row, col, 1, 1));
if (span.length > 0) {
return {rowSpan: span[0].rowCount, colSpan: span[0].colCount};
} else {
return {rowSpan: 1, colSpan: 1};
}
}
function getResultSearchinSheetEnd(searchCondition) {
var sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if (searchCondition.searchOrder == spreadNS.Search.SearchOrder.zOrder) {
searchCondition.findBeginRow = sheet.getActiveRowIndex();
searchCondition.findBeginColumn = sheet.getActiveColumnIndex() + 1;
} else if (searchCondition.searchOrder == spreadNS.Search.SearchOrder.nOrder) {
searchCondition.findBeginRow = sheet.getActiveRowIndex() + 1;
searchCondition.findBeginColumn = sheet.getActiveColumnIndex();
}
if ((searchCondition.searchFlags & spreadNS.Search.SearchFlags.blockRange) > 0) {
var sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
}
var searchResult = spread.search(searchCondition);
return searchResult;
}
function getResultSearchinSheetBefore(searchCondition) {
var sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if ((searchCondition.searchFlags & spreadNS.Search.SearchFlags.blockRange) > 0) {
var sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.findBeginRow = sel.row;
searchCondition.findBeginColumn = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
} else {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.findBeginRow = -1;
searchCondition.findBeginColumn = -1;
searchCondition.rowEnd = sheet.getActiveRowIndex();
searchCondition.columnEnd = sheet.getActiveColumnIndex();
}
var searchResult = spread.search(searchCondition);
return searchResult;
}
function getResultSearchinWorkbookEnd(searchCondition) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.findBeginRow = -1;
searchCondition.findBeginColumn = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = spread.getActiveSheetIndex() + 1;
searchCondition.endSheetIndex = -1;
var searchResult = spread.search(searchCondition);
return searchResult;
}
function getResultSearchinWorkbookBefore(searchCondition) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.findBeginRow = -1;
searchCondition.findBeginColumn = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = -1
searchCondition.endSheetIndex = spread.getActiveSheetIndex() - 1;
var searchResult = spread.search(searchCondition);
return searchResult;
}
function getSearchCondition() {
var searchCondition = new spreadNS.Search.SearchCondition();
var findWhat = document.getElementById('txtSearchWhat').value;
var within = document.getElementById('searchWithin').value;
var order = document.getElementById('searchOrder').value;
var lookin = document.getElementById('searchLookin').value;
var matchCase = document.getElementById('chkSearchMachCase').checked;
var matchEntire = document.getElementById('chkSearchMachEntire').checked;
var useWildCards = document.getElementById('chkSearchUseWildCards').checked;
searchCondition.searchString = findWhat;
if (within == "sheet") {
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
}
if (order == "byRows") {
searchCondition.searchOrder = spreadNS.Search.SearchOrder.zOrder;
} else {
searchCondition.searchOrder = spreadNS.Search.SearchOrder.nOrder;
}
if (lookin == "formula") {
searchCondition.searchTarget = spreadNS.Search.SearchFoundFlags.cellFormula;
} else if (lookin == "comment") {
searchCondition.searchTarget = spreadNS.Search.SearchFoundFlags.cellComment;
} else if (lookin == "tag") {
searchCondition.searchTarget = spreadNS.Search.SearchFoundFlags.cellTag;
} else {
searchCondition.searchTarget = spreadNS.Search.SearchFoundFlags.cellText;
}
if (!matchCase) {
searchCondition.searchFlags |= spreadNS.Search.SearchFlags.ignoreCase;
}
if (matchEntire) {
searchCondition.searchFlags |= spreadNS.Search.SearchFlags.exactMatch;
}
if (useWildCards) {
searchCondition.searchFlags |= spreadNS.Search.SearchFlags.useWildCards;
}
return searchCondition;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p>Use these options to specify what to search for in Spread.</p>
<div>
<label>Find what:</label>
<input id="txtSearchWhat"/>
</div>
<div>
<label>Within:</label>
<select id="searchWithin">
<option value="sheet" selected>Sheet</option>
<option value="workbook">Workbook</option>
</select>
<input id="chkSearchMachCase" type="checkbox" />
<label for="chkSearchMachCase">Match case</label>
</div>
<div>
<label>Look in:</label>
<select id="searchLookin">
<option value="value" selected>Values</option>
<option value="formula">Formulas</option>
<option value="tag">Cell Tag</option>
<option value="comment">Comments</option>
</select>
<input id="chkSearchMachEntire" type="checkbox" />
<label for="chkSearchMachEntire">Match exactly</label>
</div>
<div>
<label>Search:</label>
<select id="searchOrder">
<option value="byRows" selected>By Rows</option>
<option value="byColumns">By Columns</option>
</select>
<div>
<input id="chkSearchUseWildCards" type="checkbox" />
<label for="chkSearchUseWildCards">Use wildcards</label>
</div>
</div>
<div>
<label></label>
<input id="btnFindNext" type="button" value="Find Next" />
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
label {
display: inline-block;
margin: 8px 0 6px;
}
input[type="checkbox"] {
margin: 6px 0;
width: auto;
}
input,
select {
padding: 4px 6px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

To search for a specific text string or number, use the search method to search the text in cells with the specified criteria, as shown in the following example:
Use the SearchCondition to customize the search parameters.
The search result is an object with the following properties:
searchFoundFlag: An enumeration that specifies what is matched.
foundSheetIndex: The index of the sheet in which a match is found.
foundRowIndex: The index of the row at which a match is found.
foundColumnIndex: The index of the column at which a match is found.
foundString: The found string.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
txtSearchWhat = "";
searchWithin = "sheet";
searchOrder = "byRows";
searchLookin = "value";
chkSearchMachCase = false;
chkSearchMachEntire = false;
chkSearchUseWildCards = false;
constructor() {
}
initSheet(sheet: GC.Spread.Sheets.Worksheet) {
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 100);
sheet.setValue(0, 0, 'Value');
sheet.setValue(1, 0, 1);
sheet.setValue(2, 0, 2);
sheet.setValue(3, 0, 3);
sheet.addSpan(0, 1, 1, 2);
sheet.setValue(0, 1, 'Formula Result');
sheet.setValue(1, 1, 'SUM(A2:A3)');
sheet.setFormula(1, 2, '=SUM(A2:A3)');
var comment = null
sheet.setTag(6, 2, "tag: C7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 2).comment(comment);
sheet.setTag(16, 2, "tag: C17");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C17");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(16, 2).comment(comment);
sheet.setTag(6, 8, "tag: I7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 8).comment(comment);
sheet.setTag(11, 8, "tag: I12");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I12");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(11, 8).comment(comment);
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
this.initSheet(sheet1);
let sheet2 = spread.getSheet(1);
this.initSheet(sheet2);
spread.resumePaint();
}
changeTxtSearchWhat(e: any) {
this.txtSearchWhat = e.target.value;
}
changeSearchWithin(e: any) {
this.searchWithin = e.target.value;
}
changeSearchOrder(e: any) {
this.searchOrder = e.target.value;
}
changeSearchLookin(e: any) {
this.searchLookin = e.target.value;
}
changeChkSearchMachCase(e: any) {
this.chkSearchMachCase = e.target.checked;
}
changeChkSearchMachEntire(e: any) {
this.chkSearchMachEntire = e.target.checked;
}
changeChkSearchUseWildCards(e: any) {
this.chkSearchUseWildCards = e.target.checked;
}
findNext(e: any) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let searchCondition = this.getSearchCondition(spread);
let within = this.searchWithin;
let searchResult = null;
if (within == "sheet") {
let sels = sheet.getSelections();
if (sels.length > 1) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
} else if (sels.length == 1) {
let spanInfo = this.getSpanInfo(sheet, sels[0].row, sels[0].col);
if (sels[0].rowCount != spanInfo.rowSpan && sels[0].colCount != spanInfo.colSpan) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
}
}
searchResult = this.getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinSheetBefore(spread, searchCondition);
}
} else if (within == "workbook") {
searchResult = this.getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinWorkbookEnd(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinWorkbookBefore(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinSheetBefore(spread, searchCondition);
}
}
if (searchResult != null && searchResult.searchFoundFlag != GC.Spread.Sheets.Search.SearchFoundFlags.none) {
spread.setActiveSheetIndex(searchResult.foundSheetIndex);
let sheet = spread.getActiveSheet();
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex);
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) == 0) {
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex, 1, 1);
}
//scrolling
if (searchResult.foundRowIndex < sheet.getViewportTopRow(1)
|| searchResult.foundRowIndex > sheet.getViewportBottomRow(1)
|| searchResult.foundColumnIndex < sheet.getViewportLeftColumn(1)
|| searchResult.foundColumnIndex > sheet.getViewportRightColumn(1)
) {
sheet.showCell(searchResult.foundRowIndex,
searchResult.foundColumnIndex,
GC.Spread.Sheets.VerticalPosition.center,
GC.Spread.Sheets.HorizontalPosition.center);
} else {
sheet.repaint();
}
} else {
//Not Found
alert('Not Found');
}
}
getSpanInfo(sheet: GC.Spread.Sheets.Worksheet, row: number, col: number) {
let span = sheet.getSpans(new GC.Spread.Sheets.Range(row, col, 1, 1));
if (span.length > 0) {
return { rowSpan: span[0].rowCount, colSpan: span[0].colCount };
} else {
return { rowSpan: 1, colSpan: 1 };
}
}
getResultSearchinSheetEnd(spread: GC.Spread.Sheets.Workbook, searchCondition: any) {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.zOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex();
searchCondition.columnStart = sheet.getActiveColumnIndex() + 1;
} else if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.nOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex() + 1;
searchCondition.columnStart = sheet.getActiveColumnIndex();
}
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
}
let searchResult = spread.search(searchCondition);
return searchResult;
}
getResultSearchinSheetBefore(spread: GC.Spread.Sheets.Workbook, searchCondition: any) {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
} else {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = sheet.getActiveRowIndex();
searchCondition.columnEnd = sheet.getActiveColumnIndex();
}
let searchResult = spread.search(searchCondition);
return searchResult;
}
getResultSearchinWorkbookEnd(spread: GC.Spread.Sheets.Workbook, searchCondition: any) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = spread.getActiveSheetIndex() + 1;
searchCondition.endSheetIndex = -1;
let searchResult = spread.search(searchCondition);
return searchResult;
}
getResultSearchinWorkbookBefore(spread: GC.Spread.Sheets.Workbook, searchCondition: any) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = -1
searchCondition.endSheetIndex = spread.getActiveSheetIndex() - 1;
let searchResult = spread.search(searchCondition);
return searchResult;
}
getSearchCondition(spread: GC.Spread.Sheets.Workbook) {
let searchCondition = new GC.Spread.Sheets.Search.SearchCondition();
let findWhat = this.txtSearchWhat;
let within = this.searchWithin;
let order = this.searchOrder;
let lookin = this.searchLookin;
let matchCase = this.chkSearchMachCase;
let matchEntire = this.chkSearchMachEntire;
let useWildCards = this.chkSearchUseWildCards;
searchCondition.searchString = findWhat;
if (within == "sheet") {
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
}
if (order == "byRows") {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.zOrder;
} else {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.nOrder;
}
if (lookin == "formula") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellFormula;
} else if (lookin == "comment") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellComment;
} else if (lookin == "tag") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellTag;
} else {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellText;
}
if (!matchCase) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.ignoreCase;
}
if (matchEntire) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.exactMatch;
}
if (useWildCards) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.useWildCards;
}
return searchCondition;
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>Use these options to specify what to search for in Spread.</p>
<div>
<label>Find what:</label>
<input id="txtSearchWhat" (change)="changeTxtSearchWhat($event)" />
</div>
<div>
<label>Within:</label>
<select id="searchWithin" (change)="changeSearchWithin($event)">
<option value="sheet" selected>Sheet</option>
<option value="workbook">Workbook</option>
</select>
<input id="chkSearchMachCase" type="checkbox" (change)="changeChkSearchMachCase($event)" />
<label for="chkSearchMachCase">Match case</label>
</div>
<div>
<label>Look in:</label>
<select id="searchLookin" (change)="changeSearchLookin($event)">
<option value="value" selected>Values</option>
<option value="formula">Formulas</option>
<option value="tag">Cell Tag</option>
<option value="comment">Comments</option>
</select>
<input id="chkSearchMachEntire" type="checkbox" (change)="changeChkSearchMachEntire($event)" />
<label for="chkSearchMachEntire">Match exactly</label>
</div>
<div>
<label>Search:</label>
<select id="searchOrder" (change)="changeSearchOrder($event)">
<option value="byRows" selected>By Rows</option>
<option value="byColumns">By Columns</option>
</select>
<div>
<input id="chkSearchUseWildCards" type="checkbox" (change)="changeChkSearchUseWildCards($event)" />
<label for="chkSearchUseWildCards">Use wildcards</label>
</div>
</div>
<div>
<label></label>
<input id="btnFindNext" type="button" value="Find Next" (click)="findNext($event)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
label {
display: inline-block;
margin: 8px 0 6px;
}
input[type="checkbox"] {
margin: 6px 0;
width: auto;
}
input,
select {
padding: 4px 6px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

To search for a specific text string or number, use the search method to search the text in cells with the specified criteria, as shown in the following example:
Use the SearchCondition to customize the search parameters.
The search result is an object with the following properties:
searchFoundFlag: An enumeration that specifies what is matched.
foundSheetIndex: The index of the sheet in which a match is found.
foundRowIndex: The index of the row at which a match is found.
foundColumnIndex: The index of the column at which a match is found.
foundString: The found string.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { useState } from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [txtSearchWhat, setTxtSearchWhat] = useState('');
const [searchWithin, setSearchWithin] = useState('sheet');
const [searchOrder, setSearchOrder] = useState('byRows');
const [searchLookin, setSearchLookin] = useState('value');
const [chkSearchMachCase, setChkSearchMachCase] = useState(false);
const [chkSearchMachEntire, setChkSearchMachEntire] = useState(false);
const [chkSearchUseWildCards, setChkSearchUseWildCards] = useState(false);
const initSheet = (sheet) => {
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 100);
sheet.setValue(0, 0, 'Value');
sheet.setValue(1, 0, 1);
sheet.setValue(2, 0, 2);
sheet.setValue(3, 0, 3);
sheet.addSpan(0, 1, 1, 2);
sheet.setValue(0, 1, 'Formula Result');
sheet.setValue(1, 1, 'SUM(A2:A3)');
sheet.setFormula(1, 2, '=SUM(A2:A3)');
var comment = null
sheet.setTag(6, 2, "tag: C7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 2).comment(comment);
sheet.setTag(16, 2, "tag: C17");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C17");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(16, 2).comment(comment);
sheet.setTag(6, 8, "tag: I7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 8).comment(comment);
sheet.setTag(11, 8, "tag: I12");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I12");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(11, 8).comment(comment);
}
const initSpread = (spread) => {
setSpread(spread);
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
initSheet(sheet1);
let sheet2 = spread.getSheet(1);
initSheet(sheet2);
spread.resumePaint();
}
const changeTxtSearchWhat = (e) => {
setTxtSearchWhat(e.target.value);
}
const changeSearchWithin = (e) => {
setSearchWithin(e.target.value);
}
const changeSearchOrder = (e) => {
setSearchOrder(e.target.value);
}
const changeSearchLookin = (e) => {
setSearchLookin(e.target.value);
}
const changeChkSearchMachCase = (e) => {
setChkSearchMachCase(e.target.checked);
}
const changeChkSearchMachEntire = (e) => {
setChkSearchMachEntire(e.target.checked);
}
const changeChkSearchUseWildCards = (e) => {
setChkSearchUseWildCards(e.target.checked);
}
const findNext = (e) => {
let sheet = spread.getActiveSheet();
let searchCondition = getSearchCondition(spread);
let within = searchWithin;
let searchResult = null;
if (within == "sheet") {
let sels = sheet.getSelections();
if (sels.length > 1) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
} else if (sels.length == 1) {
let spanInfo = getSpanInfo(sheet, sels[0].row, sels[0].col);
if (sels[0].rowCount != spanInfo.rowSpan && sels[0].colCount != spanInfo.colSpan) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
}
}
searchResult = getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinSheetBefore(spread, searchCondition);
}
} else if (within == "workbook") {
searchResult = getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinWorkbookEnd(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinWorkbookBefore(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = getResultSearchinSheetBefore(spread, searchCondition);
}
}
if (searchResult != null && searchResult.searchFoundFlag != GC.Spread.Sheets.Search.SearchFoundFlags.none) {
spread.setActiveSheetIndex(searchResult.foundSheetIndex);
let sheet = spread.getActiveSheet();
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex);
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) == 0) {
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex, 1, 1);
}
//scrolling
if (searchResult.foundRowIndex < sheet.getViewportTopRow(1)
|| searchResult.foundRowIndex > sheet.getViewportBottomRow(1)
|| searchResult.foundColumnIndex < sheet.getViewportLeftColumn(1)
|| searchResult.foundColumnIndex > sheet.getViewportRightColumn(1)
) {
sheet.showCell(searchResult.foundRowIndex,
searchResult.foundColumnIndex,
GC.Spread.Sheets.VerticalPosition.center,
GC.Spread.Sheets.HorizontalPosition.center);
} else {
sheet.repaint();
}
} else {
//Not Found
alert('Not Found');
}
}
const getSpanInfo = (sheet, row, col) => {
let span = sheet.getSpans(new GC.Spread.Sheets.Range(row, col, 1, 1));
if (span.length > 0) {
return { rowSpan: span[0].rowCount, colSpan: span[0].colCount };
} else {
return { rowSpan: 1, colSpan: 1 };
}
}
const getResultSearchinSheetEnd = (spread, searchCondition) => {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.zOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex();
searchCondition.columnStart = sheet.getActiveColumnIndex() + 1;
} else if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.nOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex() + 1;
searchCondition.columnStart = sheet.getActiveColumnIndex();
}
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
}
let searchResult = spread.search(searchCondition);
return searchResult;
}
const getResultSearchinSheetBefore = (spread, searchCondition) => {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
} else {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = sheet.getActiveRowIndex();
searchCondition.columnEnd = sheet.getActiveColumnIndex();
}
let searchResult = spread.search(searchCondition);
return searchResult;
}
const getResultSearchinWorkbookEnd = (spread, searchCondition) => {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = spread.getActiveSheetIndex() + 1;
searchCondition.endSheetIndex = -1;
let searchResult = spread.search(searchCondition);
return searchResult;
}
const getResultSearchinWorkbookBefore = (spread, searchCondition) => {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = -1
searchCondition.endSheetIndex = spread.getActiveSheetIndex() - 1;
let searchResult = spread.search(searchCondition);
return searchResult;
}
const getSearchCondition = (spread) => {
let searchCondition = new GC.Spread.Sheets.Search.SearchCondition();
let findWhat = txtSearchWhat;
let within = searchWithin;
let order = searchOrder;
let lookin = searchLookin;
let matchCase = chkSearchMachCase;
let matchEntire = chkSearchMachEntire;
let useWildCards = chkSearchUseWildCards;
searchCondition.searchString = findWhat;
if (within == "sheet") {
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
}
if (order == "byRows") {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.zOrder;
} else {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.nOrder;
}
if (lookin == "formula") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellFormula;
} else if (lookin == "comment") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellComment;
} else if (lookin == "tag") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellTag;
} else {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellText;
}
if (!matchCase) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.ignoreCase;
}
if (matchEntire) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.exactMatch;
}
if (useWildCards) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.useWildCards;
}
return searchCondition;
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet></Worksheet>
<Worksheet></Worksheet>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<p>Use these options to specify what to search for in Spread.</p>
<div>
<label>Find what:</label>
<input id="txtSearchWhat" onChange={e => changeTxtSearchWhat(e)} />
</div>
<div>
<label>Within:</label>
<select id="searchWithin" onChange={e => changeSearchWithin(e)}>
<option value="sheet" selected>Sheet</option>
<option value="workbook">Workbook</option>
</select>
<input id="chkSearchMachCase" type="checkbox" onChange={e => changeChkSearchMachCase(e)} />
<label htmlFor="chkSearchMachCase">Match case</label>
</div>
<div>
<label>Look in:</label>
<select id="searchLookin" onChange={e => changeSearchLookin(e)}>
<option value="value" selected>Values</option>
<option value="formula">Formulas</option>
<option value="tag">Cell Tag</option>
<option value="comment">Comments</option>
</select>
<input id="chkSearchMachEntire" type="checkbox" onChange={e => changeChkSearchMachEntire(e)} />
<label htmlFor="chkSearchMachEntire">Match exactly</label>
</div>
<div>
<label>Search:</label>
<select id="searchOrder" onChange={e => changeSearchOrder(e)}>
<option value="byRows" selected>By Rows</option>
<option value="byColumns">By Columns</option>
</select>
<div>
<input id="chkSearchUseWildCards" type="checkbox" onChange={e => changeChkSearchUseWildCards(e)} />
<label htmlFor="chkSearchUseWildCards">Use wildcards</label>
</div>
</div>
<div>
<label />
<input id="btnFindNext" type="button" defaultValue="Find Next" onClick={e => findNext(e)} />
</div>
</div>
</div>;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.txtSearchWhat = "";
this.searchWithin = "sheet";
this.searchOrder = "byRows";
this.searchLookin = "value";
this.chkSearchMachCase = false;
this.chkSearchMachEntire = false;
this.chkSearchUseWildCards = false;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet></Worksheet>
<Worksheet></Worksheet>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div className="options-container">
<p>Use these options to specify what to search for in Spread.</p>
<div>
<label>Find what:</label>
<input id="txtSearchWhat" onChange={e=>this.changeTxtSearchWhat(e)}/>
</div>
<div>
<label>Within:</label>
<select id="searchWithin" onChange={e=>this.changeSearchWithin(e)}>
<option value="sheet" selected>Sheet</option>
<option value="workbook">Workbook</option>
</select>
<input id="chkSearchMachCase" type="checkbox" onChange={e=>this.changeChkSearchMachCase(e)}/>
<label htmlFor="chkSearchMachCase">Match case</label>
</div>
<div>
<label>Look in:</label>
<select id="searchLookin" onChange={e=>this.changeSearchLookin(e)}>
<option value="value" selected>Values</option>
<option value="formula">Formulas</option>
<option value="tag">Cell Tag</option>
<option value="comment">Comments</option>
</select>
<input id="chkSearchMachEntire" type="checkbox" onChange={e=>this.changeChkSearchMachEntire(e)}/>
<label htmlFor="chkSearchMachEntire">Match exactly</label>
</div>
<div>
<label>Search:</label>
<select id="searchOrder" onChange={e=>this.changeSearchOrder(e)}>
<option value="byRows" selected>By Rows</option>
<option value="byColumns">By Columns</option>
</select>
<div>
<input id="chkSearchUseWildCards" type="checkbox" onChange={e=>this.changeChkSearchUseWildCards(e)}/>
<label htmlFor="chkSearchUseWildCards">Use wildcards</label>
</div>
</div>
<div>
<label />
<input id="btnFindNext" type="button" defaultValue="Find Next" onClick={e=>this.findNext(e)}/>
</div>
</div>
</div>;
}
initSheet(sheet) {
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 100);
sheet.setValue(0, 0, 'Value');
sheet.setValue(1, 0, 1);
sheet.setValue(2, 0, 2);
sheet.setValue(3, 0, 3);
sheet.addSpan(0, 1, 1, 2);
sheet.setValue(0, 1, 'Formula Result');
sheet.setValue(1, 1, 'SUM(A2:A3)');
sheet.setFormula(1, 2, '=SUM(A2:A3)');
var comment = null
sheet.setTag(6, 2, "tag: C7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 2).comment(comment);
sheet.setTag(16, 2, "tag: C17");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C17");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(16, 2).comment(comment);
sheet.setTag(6, 8, "tag: I7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 8).comment(comment);
sheet.setTag(11, 8, "tag: I12");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I12");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(11, 8).comment(comment);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
this.initSheet(sheet1);
let sheet2 = spread.getSheet(1);
this.initSheet(sheet2);
spread.resumePaint();
}
changeTxtSearchWhat(e) {
this.txtSearchWhat = e.target.value;
}
changeSearchWithin(e) {
this.searchWithin = e.target.value;
}
changeSearchOrder(e) {
this.searchOrder = e.target.value;
}
changeSearchLookin(e) {
this.searchLookin = e.target.value;
}
changeChkSearchMachCase(e) {
this.chkSearchMachCase = e.target.checked;
}
changeChkSearchMachEntire(e) {
this.chkSearchMachEntire = e.target.checked;
}
changeChkSearchUseWildCards(e) {
this.chkSearchUseWildCards = e.target.checked;
}
findNext(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let searchCondition = this.getSearchCondition(spread);
let within = this.searchWithin;
let searchResult = null;
if (within == "sheet") {
let sels = sheet.getSelections();
if (sels.length > 1) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
} else if (sels.length == 1) {
let spanInfo = this.getSpanInfo(sheet, sels[0].row, sels[0].col);
if (sels[0].rowCount != spanInfo.rowSpan && sels[0].colCount != spanInfo.colSpan) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
}
}
searchResult = this.getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinSheetBefore(spread, searchCondition);
}
} else if (within == "workbook") {
searchResult = this.getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinWorkbookEnd(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinWorkbookBefore(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinSheetBefore(spread, searchCondition);
}
}
if (searchResult != null && searchResult.searchFoundFlag != GC.Spread.Sheets.Search.SearchFoundFlags.none) {
spread.setActiveSheetIndex(searchResult.foundSheetIndex);
let sheet = spread.getActiveSheet();
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex);
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) == 0) {
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex, 1, 1);
}
//scrolling
if (searchResult.foundRowIndex < sheet.getViewportTopRow(1)
|| searchResult.foundRowIndex > sheet.getViewportBottomRow(1)
|| searchResult.foundColumnIndex < sheet.getViewportLeftColumn(1)
|| searchResult.foundColumnIndex > sheet.getViewportRightColumn(1)
) {
sheet.showCell(searchResult.foundRowIndex,
searchResult.foundColumnIndex,
GC.Spread.Sheets.VerticalPosition.center,
GC.Spread.Sheets.HorizontalPosition.center);
} else {
sheet.repaint();
}
} else {
//Not Found
alert('Not Found');
}
}
getSpanInfo(sheet, row, col) {
let span = sheet.getSpans(new GC.Spread.Sheets.Range(row, col, 1, 1));
if (span.length > 0) {
return { rowSpan: span[0].rowCount, colSpan: span[0].colCount };
} else {
return { rowSpan: 1, colSpan: 1 };
}
}
getResultSearchinSheetEnd(spread, searchCondition) {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.zOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex();
searchCondition.columnStart = sheet.getActiveColumnIndex() + 1;
} else if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.nOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex() + 1;
searchCondition.columnStart = sheet.getActiveColumnIndex();
}
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
}
let searchResult = spread.search(searchCondition);
return searchResult;
}
getResultSearchinSheetBefore(spread, searchCondition) {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
} else {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = sheet.getActiveRowIndex();
searchCondition.columnEnd = sheet.getActiveColumnIndex();
}
let searchResult = spread.search(searchCondition);
return searchResult;
}
getResultSearchinWorkbookEnd(spread, searchCondition) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = spread.getActiveSheetIndex() + 1;
searchCondition.endSheetIndex = -1;
let searchResult = spread.search(searchCondition);
return searchResult;
}
getResultSearchinWorkbookBefore(spread, searchCondition) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = -1
searchCondition.endSheetIndex = spread.getActiveSheetIndex() - 1;
let searchResult = spread.search(searchCondition);
return searchResult;
}
getSearchCondition(spread) {
let searchCondition = new GC.Spread.Sheets.Search.SearchCondition();
let findWhat = this.txtSearchWhat;
let within = this.searchWithin;
let order = this.searchOrder;
let lookin = this.searchLookin;
let matchCase = this.chkSearchMachCase;
let matchEntire = this.chkSearchMachEntire;
let useWildCards = this.chkSearchUseWildCards;
searchCondition.searchString = findWhat;
if (within == "sheet") {
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
}
if (order == "byRows") {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.zOrder;
} else {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.nOrder;
}
if (lookin == "formula") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellFormula;
} else if (lookin == "comment") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellComment;
} else if (lookin == "tag") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellTag;
} else {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellText;
}
if (!matchCase) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.ignoreCase;
}
if (matchEntire) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.exactMatch;
}
if (useWildCards) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.useWildCards;
}
return searchCondition;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
label {
display: inline-block;
margin: 8px 0 6px;
}
input[type="checkbox"] {
margin: 6px 0;
width: auto;
}
input,
select {
padding: 4px 6px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

To search for a specific text string or number, use the search method to search the text in cells with the specified criteria, as shown in the following example:
Use the SearchCondition to customize the search parameters.
The search result is an object with the following properties:
searchFoundFlag: An enumeration that specifies what is matched.
foundSheetIndex: The index of the sheet in which a match is found.
foundRowIndex: The index of the row at which a match is found.
foundColumnIndex: The index of the column at which a match is found.
foundString: The found string.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<p>Use these options to specify what to search for in Spread.</p>
<div>
<label>Find what:</label>
<input id="txtSearchWhat" @change="changeTxtSearchWhat" />
</div>
<div>
<label>Within:</label>
<select id="searchWithin" @change="changeSearchWithin">
<option value="sheet" selected>Sheet</option>
<option value="workbook">Workbook</option>
</select>
<input id="chkSearchMachCase" type="checkbox" @change="changeChkSearchMachCase" />
<label for="chkSearchMachCase">Match case</label>
</div>
<div>
<label>Look in:</label>
<select id="searchLookin" @change="changeSearchLookin">
<option value="value" selected>Values</option>
<option value="formula">Formulas</option>
<option value="tag">Cell Tag</option>
<option value="comment">Comments</option>
</select>
<input id="chkSearchMachEntire" type="checkbox" @change="changeChkSearchMachEntire" />
<label for="chkSearchMachEntire">Match exactly</label>
</div>
<div>
<label>Search:</label>
<select id="searchOrder" @change="changeSearchOrder">
<option value="byRows" selected>By Rows</option>
<option value="byColumns">By Columns</option>
</select>
<div>
<input id="chkSearchUseWildCards" type="checkbox" @change="changeChkSearchUseWildCards" />
<label for="chkSearchUseWildCards">Use wildcards</label>
</div>
</div>
<div>
<label></label>
<input id="btnFindNext" type="button" value="Find Next" @click="findNext" />
</div>
</div>
</div>
</template>
<script>
import Vue from "vue";
import "@mescius/spread-sheets-vue";
import GC from "@mescius/spread-sheets";
import "./styles.css";
let App = Vue.extend({
name: "app",
data: function () {
return {
spread: null,
txtSearchWhat: "",
searchWithin: "sheet",
searchOrder: "byRows",
searchLookin: "value",
chkSearchMachCase: false,
chkSearchMachEntire: false,
chkSearchUseWildCards: false
};
},
methods: {
initSheet: function (sheet) {
sheet.setColumnWidth(0, 100);
sheet.setColumnWidth(1, 100);
sheet.setValue(0, 0, 'Value');
sheet.setValue(1, 0, 1);
sheet.setValue(2, 0, 2);
sheet.setValue(3, 0, 3);
sheet.addSpan(0, 1, 1, 2);
sheet.setValue(0, 1, 'Formula Result');
sheet.setValue(1, 1, 'SUM(A2:A3)');
sheet.setFormula(1, 2, '=SUM(A2:A3)');
var comment = null
sheet.setTag(6, 2, "tag: C7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 2).comment(comment);
sheet.setTag(16, 2, "tag: C17");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: C17");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(16, 2).comment(comment);
sheet.setTag(6, 8, "tag: I7");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I7");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(6, 8).comment(comment);
sheet.setTag(11, 8, "tag: I12");
comment = new GC.Spread.Sheets.Comments.Comment();
comment.text("tag: I12");
comment.backColor("yellow");
comment.foreColor("green");
comment.displayMode(GC.Spread.Sheets.Comments.DisplayMode.alwaysShown);
comment.autoSize(true);
sheet.getCell(11, 8).comment(comment);
},
initSpread: function (spread) {
this.spread = spread;
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
this.initSheet(sheet1);
let sheet2 = spread.getSheet(1);
sheet2.setColumnWidth(0, 100);
this.initSheet(sheet2);
spread.resumePaint();
},
changeTxtSearchWhat(e) {
this.txtSearchWhat = e.target.value;
},
changeSearchWithin(e) {
this.searchWithin = e.target.value;
},
changeSearchOrder(e) {
this.searchOrder = e.target.value;
},
changeSearchLookin(e) {
this.searchLookin = e.target.value;
},
changeChkSearchMachCase(e) {
this.chkSearchMachCase = e.target.checked;
},
changeChkSearchMachEntire(e) {
this.chkSearchMachEntire = e.target.checked;
},
changeChkSearchUseWildCards(e) {
this.chkSearchUseWildCards = e.target.checked;
},
findNext(e) {
let spread = this.spread;
let sheet = spread.getActiveSheet();
let searchCondition = this.getSearchCondition(spread);
let within = this.searchWithin;
let searchResult = null;
if (within == "sheet") {
let sels = sheet.getSelections();
if (sels.length > 1) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
} else if (sels.length == 1) {
let spanInfo = this.getSpanInfo(sheet, sels[0].row, sels[0].col);
if (sels[0].rowCount != spanInfo.rowSpan && sels[0].colCount != spanInfo.colSpan) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.blockRange;
}
}
searchResult = this.getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinSheetBefore(spread, searchCondition);
}
} else if (within == "workbook") {
searchResult = this.getResultSearchinSheetEnd(spread, searchCondition);
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinWorkbookEnd(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinWorkbookBefore(spread, searchCondition);
}
if (searchResult == null || searchResult.searchFoundFlag == GC.Spread.Sheets.Search.SearchFoundFlags.none) {
searchResult = this.getResultSearchinSheetBefore(spread, searchCondition);
}
}
if (searchResult != null && searchResult.searchFoundFlag != GC.Spread.Sheets.Search.SearchFoundFlags.none) {
spread.setActiveSheetIndex(searchResult.foundSheetIndex);
let sheet = spread.getActiveSheet();
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex);
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) == 0) {
sheet.setActiveCell(searchResult.foundRowIndex, searchResult.foundColumnIndex, 1, 1);
}
//scrolling
if (searchResult.foundRowIndex < sheet.getViewportTopRow(1) ||
searchResult.foundRowIndex > sheet.getViewportBottomRow(1) ||
searchResult.foundColumnIndex < sheet.getViewportLeftColumn(1) ||
searchResult.foundColumnIndex > sheet.getViewportRightColumn(1)
) {
sheet.showCell(searchResult.foundRowIndex,
searchResult.foundColumnIndex,
GC.Spread.Sheets.VerticalPosition.center,
GC.Spread.Sheets.HorizontalPosition.center);
} else {
sheet.repaint();
}
} else {
//Not Found
alert('Not Found');
}
},
getSpanInfo(sheet, row, col) {
let span = sheet.getSpans(new GC.Spread.Sheets.Range(row, col, 1, 1));
if (span.length > 0) {
return {
rowSpan: span[0].rowCount,
colSpan: span[0].colCount
};
} else {
return {
rowSpan: 1,
colSpan: 1
};
}
},
getResultSearchinSheetEnd(spread, searchCondition) {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.zOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex();
searchCondition.columnStart = sheet.getActiveColumnIndex() + 1;
} else if (searchCondition.searchOrder == GC.Spread.Sheets.Search.SearchOrder.nOrder) {
searchCondition.rowStart = sheet.getActiveRowIndex() + 1;
searchCondition.columnStart = sheet.getActiveColumnIndex();
}
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
}
let searchResult = spread.search(searchCondition);
return searchResult;
},
getResultSearchinSheetBefore(spread, searchCondition) {
let sheet = spread.getActiveSheet();
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
if ((searchCondition.searchFlags & GC.Spread.Sheets.Search.SearchFlags.blockRange) > 0) {
let sel = sheet.getSelections()[0];
searchCondition.rowStart = sel.row;
searchCondition.columnStart = sel.col;
searchCondition.rowEnd = sel.row + sel.rowCount - 1;
searchCondition.columnEnd = sel.col + sel.colCount - 1;
} else {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = sheet.getActiveRowIndex();
searchCondition.columnEnd = sheet.getActiveColumnIndex();
}
let searchResult = spread.search(searchCondition);
return searchResult;
},
getResultSearchinWorkbookEnd(spread, searchCondition) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = spread.getActiveSheetIndex() + 1;
searchCondition.endSheetIndex = -1;
let searchResult = spread.search(searchCondition);
return searchResult;
},
getResultSearchinWorkbookBefore(spread, searchCondition) {
searchCondition.rowStart = -1;
searchCondition.columnStart = -1;
searchCondition.rowEnd = -1;
searchCondition.columnEnd = -1;
searchCondition.startSheetIndex = -1
searchCondition.endSheetIndex = spread.getActiveSheetIndex() - 1;
let searchResult = spread.search(searchCondition);
return searchResult;
},
getSearchCondition(spread) {
let searchCondition = new GC.Spread.Sheets.Search.SearchCondition();
let findWhat = this.txtSearchWhat;
let within = this.searchWithin;
let order = this.searchOrder;
let lookin = this.searchLookin;
let matchCase = this.chkSearchMachCase;
let matchEntire = this.chkSearchMachEntire;
let useWildCards = this.chkSearchUseWildCards;
searchCondition.searchString = findWhat;
if (within == "sheet") {
searchCondition.startSheetIndex = spread.getActiveSheetIndex();
searchCondition.endSheetIndex = spread.getActiveSheetIndex();
}
if (order == "byRows") {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.zOrder;
} else {
searchCondition.searchOrder = GC.Spread.Sheets.Search.SearchOrder.nOrder;
}
if (lookin == "formula") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellFormula;
} else if (lookin == "comment") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellComment;
} else if (lookin == "tag") {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellTag;
} else {
searchCondition.searchTarget = GC.Spread.Sheets.Search.SearchFoundFlags.cellText;
}
if (!matchCase) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.ignoreCase;
}
if (matchEntire) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.exactMatch;
}
if (useWildCards) {
searchCondition.searchFlags |= GC.Spread.Sheets.Search.SearchFlags.useWildCards;
}
return searchCondition;
}
}
});
new Vue({
render: h => h(App)
}).$mount("#app");
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/en/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
label {
display: inline-block;
margin: 8px 0 6px;
}
input[type="checkbox"] {
margin: 6px 0;
width: auto;
}
input,
select {
padding: 4px 6px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);